package com.zhongzheng.modules.bank.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.bank.bo.QuestionBankSectionAddBo;
import com.zhongzheng.modules.bank.bo.QuestionBankSectionEditBo;
import com.zhongzheng.modules.bank.bo.QuestionBankSectionQueryBo;
import com.zhongzheng.modules.bank.domain.QuestionBankSection;
import com.zhongzheng.modules.bank.mapper.QuestionBankMapper;
import com.zhongzheng.modules.bank.mapper.QuestionBankSectionMapper;
import com.zhongzheng.modules.bank.service.IQuestionBankSectionService;
import com.zhongzheng.modules.bank.vo.QuestionBankSectionVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 题库小节Service业务层处理
 *
 * @author ruoyi
 * @date 2021-05-20
 */
@Service
public class QuestionBankSectionServiceImpl extends ServiceImpl<QuestionBankSectionMapper, QuestionBankSection> implements IQuestionBankSectionService {

    @Autowired
    private QuestionBankSectionMapper questionBankSectionMapper;

    @Override
    public QuestionBankSectionVo queryById(Long bankSectionId){
        QuestionBankSection db = this.baseMapper.selectById(bankSectionId);
        return BeanUtil.toBean(db, QuestionBankSectionVo.class);
    }

    @Override
    public List<QuestionBankSectionVo> queryList(QuestionBankSectionQueryBo bo) {
        LambdaQueryWrapper<QuestionBankSection> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getBankChapterId() != null, QuestionBankSection::getBankChapterId, bo.getBankChapterId());
        lqw.like(StrUtil.isNotBlank(bo.getName()), QuestionBankSection::getName, bo.getName());
        lqw.eq(bo.getStatus() != null, QuestionBankSection::getStatus, bo.getStatus());
        lqw.eq(bo.getSort() != null, QuestionBankSection::getSort, bo.getSort());
        return entity2Vo(this.list(lqw));
    }

    @Override
    public List<QuestionBankSectionVo> selectBankSectionList(QuestionBankSectionQueryBo bo) {
        return questionBankSectionMapper.selectBankSectionList(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<QuestionBankSectionVo> entity2Vo(Collection<QuestionBankSection> collection) {
        List<QuestionBankSectionVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, QuestionBankSectionVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<QuestionBankSection> page = (Page<QuestionBankSection>)collection;
            Page<QuestionBankSectionVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(QuestionBankSectionAddBo bo) {
        QuestionBankSection add = BeanUtil.toBean(bo, QuestionBankSection.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(QuestionBankSectionEditBo bo) {
        QuestionBankSection update = BeanUtil.toBean(bo, QuestionBankSection.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(QuestionBankSection entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
